/* BLOB.H - Programmed by Maarten Hofman */
/* 100404: Started programming */
/* 180404: Added parenting and other fun animation features, like rotation */
/* 190404: Make sure the parent knows it needs to rotate or not */
/* 260404: Added the has_base_name() functionality */
/* 280404: Add update functionality */
/* 060504: Added rotation functionality */
/* 040704: Added transparancy indicator */
/* 150704: Made do_rotate() more smooth */
/* 240704: Added get_parent */
/* 040804: Added target_distance() */
/* 020904: Added fluid rotates */
/* 111004: Added speed parameter */
/* 281004: Added parameter to do_rotate */
/* 011104: Added movespeed */
/* 230205: Added set_angle() */
/* 270205: Added set copy stuff */
/* 140305: Added set_location() for updates */
/* 260305: Added animy patch */

#include "ps2matrix4x4.h"
#include "blobcopy.h" 

#define MOVE_RESOLUTION (0.1*movespeed)
#define ROTATE_RESOLUTION 0.02

using namespace KazMaths;

class blob {
private:
  int texture;
  int model;
  char name[32];
  Matrix4x4 *loc;
  float cx,cy,cz;
  int tx,ty,tz;
  blob *parent;
  bool moved;
  int animtype;
  float *animation;
  int step;
  float angle,rotx,roty,rotz,crotx,croty,crotz;
  float ax,ay,az;
  float bias;
  int rotate;
  bool animate;
  bool updated;
  bool trans;
  bool copied;
  bool cupdated;
  void internal_do_rotate(float x,float y,float z);
  float ta;
  int animspeed;
  float interpolate_animation();
  int movespeed;
public:
  blob();
  ~blob();
  void update();
  void set_bias();
  void set_animation_type(int how,int speed);
  void set_animation(float *how);
  void set_copy(blobcopy *how);
  void set_parent(blob *who);
  void set_rotate(int how);
  void set_animate();
  int get_texture();
  int get_model();
  float get_angle();
  void set_angle(float how);
  void set_texture(int how);
  void set_move_speed(int how);
  void set_model(int how);
  void set_name(char *how);
  void set_relative(float x,float y,float z);
  int has_name(char *how);
  int has_base_name(char *how);
  Matrix4x4 *get_location();
  void set_location(Matrix4x4 *how);
  bool move_coordinates(int x,int y,int z);
  bool heart_beat();
  float get_cx();
  float get_cy();
  float get_cz();
  bool get_moved();
  void do_rotate(float x,float y,float z,int how);
  void set_trans();
  bool is_trans();
  void set_updated();
  bool get_updated();
  float target_distance();
};
