/* SELECTMODE.CPP - Programmed by Maarten Hofman */
/* 080504: Started programming */
/* 090504: Added dropping of items */
/* 070704: Added player score */
/* 030804: Used add_symbol to introduce the symbols */
/* 061204: Added tell option */
/* 220205: Added help files */
/* 230205: Added options */

#include "pad.h"
#include "twod.h"

window *selected;
bool swfr,shopmode;
int selcom,list_size;
char smbuf[100];
bool option_music=true,option_sound=true,option_vibrate=true;

void show_menu(window *where) {
  where->clear();
  where->add_line("Additional commands:");
  where->add_line("   Show WHO list");
  where->add_line("   Show inventory");
  where->add_line("   Show score");
  where->add_line("L1: Option screen");
  where->add_line("START: Help");
  if(shopmode) where->add_line("   Buy item");
  where->add_line("SELECT: Return to game");
  where->add_symbol(1,16,1);
  where->add_symbol(1,32,4);
  where->add_symbol(1,48,3);
  if(shopmode) where->add_symbol(1,96,2);
}

void start_select_mode(int how) {
  if(!how) {
    show_menu(selected);
    return;
  }
  selected->clear();
  selected->add_line("   or SELECT: Exit");
  selected->add_symbol(1,0,1);
  selcom=1;
}

void end_select_mode() {
  selcom=0;
  selected->clear();
}

void initialize_select_mode(twod *base) {
  selected=base->open_window(-310,-150,310,125);
  swfr=false;
  selcom=0;
}

char *handle_select_mode(float x,float y) {
char *sl;
bool oc;

  oc=false;
  /* We are in select mode */
  if(swfr) {
    /* Wait for release */
    swfr=false;
    if(pad[0].buttons&PAD_CROSS) swfr=true;
    if(pad[0].buttons&PAD_SQUARE) swfr=true;
    if(pad[0].buttons&PAD_TRI) swfr=true;
    if(pad[0].buttons&PAD_CIRCLE) swfr=true;
    if(pad[0].buttons&PAD_START) swfr=true;
    if(pad[0].buttons&PAD_L1) swfr=true;
    if(x<-0.1f) swfr=true;
    if(x>0.1f) swfr=true;
    if(y<-0.1f) swfr=true;
    if(y>0.1f) swfr=true;
    return NULL;
  }
  if(selcom) {
    if(y<-0.1f) {
      selected->move_select(1);
      swfr=true;
    }
    if(y>0.1f) {
      selected->move_select(-1);
      swfr=true;
    }
  }
  if(pad[0].buttons&PAD_CIRCLE) {
    /* Can't sell if not in inventory */
    if(selcom==2) {
      /* Can't sell if not in shop */
      if(shopmode) {
        /* Can't sell if nothing in inventory */
        if(!list_size) return NULL;
        /* Get the selected item */
        sl=selected->get_selected_line();
        sprintf(smbuf,"sell %s\n",sl);
        /* Because it might be sold, we need to drop back to the menu */
        selcom=0;
        show_menu(selected);
        swfr=true;
        return smbuf;
      }
    }
    /* Can't buy if not in shop */
    if(selcom==4) {
      if(shopmode) {
        /* Can't buy if nothing in store */
        if(!list_size) return NULL;
        /* Get the selected item */
        sl=selected->get_selected_line();
        sprintf(smbuf,"buy %s\n",sl);
        /* Because it might be bought, we need to drop back to the menu */
        selcom=0;
        show_menu(selected);
        swfr=true;
        return smbuf;
      }
    }
    /* Shop requested */
    if(shopmode) {
      selected->clear();
      selected->add_line("Shop has available:");
      selected->add_line("   exit,    buy");
      selected->add_symbol(1,16,1);
      selected->add_symbol(73,16,2);
      selcom=4;
      swfr=true;
      return "list\n";
    }
  }
  if(pad[0].buttons&PAD_TRI) {
    /* Can't drop if not in inventory */
    if(selcom==2) {
      /* Can't drop if nothing in inventory */
      if(!list_size) return NULL;
      /* Get the selected item */
      sl=selected->get_selected_line();
      sprintf(smbuf,"drop %s\n",sl);
      /* Because it was dropped, we need to drop back to the menu */
      selcom=0;
      show_menu(selected);
      swfr=true;
      return smbuf;
    }
    /* SCORE requested */
    selected->clear();
    selected->add_line("Current score:");
    selected->add_line("   exit");
    selected->add_symbol(1,16,1);
    selcom=3;
    swfr=true;
    return "score\n";
  }
  if(pad[0].buttons&PAD_SQUARE) {
    if(selcom==6) {
      /* Option change requested */
      sl=selected->get_selected_line();
      if(sl[0]=='m') option_music=!option_music;
      if(sl[0]=='s') option_sound=!option_sound;
      if(sl[0]=='v') option_vibrate=!option_vibrate;
      oc=true;
    }
  } 
  if((pad[0].buttons&PAD_L1)||(oc==true)) {
    /* Option mode */
    selected->clear();
    selected->add_line("Option menu:");
    selected->add_line("  exit,    toggle");
    if(option_music) {
      selected->add_line("music: on");
    }
    else {
      selected->add_line("music: off");
    }
    if(option_sound) {
      selected->add_line("sound: on");
    }
    else {
      selected->add_line("sound: off");
    }
    if(option_vibrate) {
      selected->add_line("vibrate: on");
    }
    else {
      selected->add_line("vibrate: off");
    }
    selected->set_select(2,4);
    selected->add_symbol(1,16,1);
    selected->add_symbol(73,16,4);
    selcom=6;
    swfr=true;
    return NULL;
  }
  if(pad[0].buttons&PAD_START) {
    /* Help mode */
    selected->clear();
    selected->add_line("Help menu:");
    selected->add_line("   exit,    view");
    selected->add_symbol(1,16,1);
    selected->add_symbol(73,16,4);
    selcom=5;
    swfr=true;
    return "help main\n";
  }
  if(pad[0].buttons&PAD_SQUARE) {
    if(selcom==2) {
      /* We are already in inventory mode, so we need to use */
      if(!list_size) return NULL;
      sl=selected->get_selected_line();
      sprintf(smbuf,"use %s\n",sl);
      selcom=0;
      show_menu(selected);
      swfr=true;
      return smbuf;
    }
    if(selcom==1) {
      /* Tell requested */
      if(!list_size) return NULL;
      sl=selected->get_selected_line();
      sprintf(smbuf,"tell %s\n",sl);
      selcom=0;
      show_menu(selected);
      swfr=true;
      return smbuf;
    }
    if(selcom==5) {
      /* Help requested */
      if(!list_size) return NULL;
      sl=selected->get_selected_line();
      sprintf(smbuf,"help %s\n",sl);
      selcom=6;
      swfr=true;
      selected->clear();
      selected->add_line("Help menu:");
      selected->add_line("   exit");
      selected->add_symbol(1,16,1);
      return smbuf;
    }
    /* INVENTORY requested */
    selected->clear();
    selected->add_line("Current inventory:");
    if(!shopmode) {
      selected->add_line("   exit,    drop,    use");
    }
    else {
      selected->add_line("   exit,    drop,    use,    sell");
    }
    selected->add_symbol(1,16,1);
    selected->add_symbol(73,16,3);
    selected->add_symbol(145,16,4);
    if(shopmode) selected->add_symbol(209,16,2);
    selcom=2;
    swfr=true;
    return "inventory\n";
  }
  if(pad[0].buttons&PAD_CROSS) {
    if(selcom) {
      selcom=0;
      show_menu(selected);
      swfr=true;
      return NULL;
    }
    /* WHO list requested */
    selected->clear();
    selected->add_line("Players that once logged in:");
    selected->add_line("   exit,    tell");
    selected->add_symbol(1,16,1);
    selected->add_symbol(73,16,4);
    selcom=1;
    swfr=true;
    return "who\n";
  }
  return NULL;
}

void select_response(char *response) {
  fprintf(stderr,"select_response() called with selcom=%d response=%s\n",selcom,
          response);
  if(!selcom) return;
  /* Make sure we know the size of the list */
  if(response[4]=='S') {
    list_size=atoi(&response[9]);
    if(!list_size) {
      selected->add_line("No inventory!");
    }
    else {
      selected->set_select(2,1+list_size);
    }
  }
  else {
    selected->add_line(&response[8]);
  }
}
