/* WINDOW.H - Programmed by Maarten Hofman */
/* 010504: Started programming */
/* 020504: Fixed scrolling in window */
/* 080504: Added select options */
/* 090504: Added get_selected_line() */
/* 030804: Added cycle to render option */

#ifndef __WINDOW_H__

#define __WINDOW_H__

#include "font.h"

#define MAX_LINES	25
#define MAX_CHARS	80
#define SCROLL_SPEED	3
#define MAX_SYMBOLS	10

class window {
private:
  int x1;
  int y1;
  int x2;
  int y2;
  char lines[MAX_LINES][MAX_CHARS];
  int scroll;
  int current;
  bool scrolling;
  int cursor;
  int speed;
  int sstart;
  int send;
  int scurrent;
  int symbols[MAX_SYMBOLS];
  int symx[MAX_SYMBOLS];
  int symy[MAX_SYMBOLS];
  int csym;
public:
  window();
  ~window();
  void add_symbol(int x,int y,int symbol);
  void set_size(int nx1,int ny1,int nx2,int ny2);
  void render(CFont *font,int cycle);
  void add_line(char *which);
  void clear();
  void set_select(int start,int end);
  void move_select(int how);
  char *get_selected_line();
};

#endif
